import { BaseTypesVisitor, ParsedTypesConfig } from 'graphql-codegen-visitor-plugin-common';
import { TypeScriptPluginConfig } from './index';
import { FieldDefinitionNode, NamedTypeNode, ListTypeNode, NonNullTypeNode, EnumTypeDefinitionNode, InputValueDefinitionNode } from 'graphql';
export interface TypeScriptPluginParsedConfig extends ParsedTypesConfig {
    avoidOptionals: boolean;
    constEnums: boolean;
    enumsAsTypes: boolean;
    immutableTypes: boolean;
    maybeValue: string;
}
export declare class TsVisitor<TRawConfig extends TypeScriptPluginConfig = TypeScriptPluginConfig, TParsedConfig extends TypeScriptPluginParsedConfig = TypeScriptPluginParsedConfig> extends BaseTypesVisitor<TRawConfig, TParsedConfig> {
    constructor(pluginConfig: TRawConfig, additionalConfig?: Partial<TParsedConfig>);
    private clearOptional;
    NamedType(node: NamedTypeNode): string;
    ListType(node: ListTypeNode): string;
    protected wrapWithListType(str: string): string;
    NonNullType(node: NonNullTypeNode): string;
    FieldDefinition(node: FieldDefinitionNode, key?: number | string, parent?: any): string;
    InputValueDefinition(node: InputValueDefinitionNode, key?: number | string, parent?: any): string;
    EnumTypeDefinition(node: EnumTypeDefinitionNode): string;
}
